Binary files 20-09-03/AcdDigi/build/redhat5-i686-32bit-gcc41-Optimized/test_AcdDigi and 20-09-04/AcdDigi/build/redhat5-i686-32bit-gcc41-Optimized/test_AcdDigi differ
Binary files 20-09-03/AcdDigi/build/redhat5-i686-32bit-gcc41-Optimized/test_AcdDigiUtil and 20-09-04/AcdDigi/build/redhat5-i686-32bit-gcc41-Optimized/test_AcdDigiUtil differ
Binary files 20-09-03/AcdRecon/build/redhat5-i686-32bit-gcc41-Optimized/test_AcdRecon and 20-09-04/AcdRecon/build/redhat5-i686-32bit-gcc41-Optimized/test_AcdRecon differ
Binary files 20-09-03/AcdUtil/build/redhat5-i686-32bit-gcc41-Optimized/libAcdUtilCommon.a and 20-09-04/AcdUtil/build/redhat5-i686-32bit-gcc41-Optimized/libAcdUtilCommon.a differ
Binary files 20-09-03/AcdUtil/build/redhat5-i686-32bit-gcc41-Optimized/test_AcdUtil and 20-09-04/AcdUtil/build/redhat5-i686-32bit-gcc41-Optimized/test_AcdUtil differ
Binary files 20-09-03/AdfEvent/build/redhat5-i686-32bit-gcc41-Optimized/libAdfEvent.a and 20-09-04/AdfEvent/build/redhat5-i686-32bit-gcc41-Optimized/libAdfEvent.a differ
Binary files 20-09-03/AdfEvent/build/redhat5-i686-32bit-gcc41-Optimized/test_AdfEvent and 20-09-04/AdfEvent/build/redhat5-i686-32bit-gcc41-Optimized/test_AdfEvent differ
Binary files 20-09-03/AnalysisNtuple/build/redhat5-i686-32bit-gcc41-Optimized/test_AnalysisNtuple and 20-09-04/AnalysisNtuple/build/redhat5-i686-32bit-gcc41-Optimized/test_AnalysisNtuple differ
Binary files 20-09-03/AncillaryDataEvent/build/redhat5-i686-32bit-gcc41-Optimized/libAncillaryDataEvent.a and 20-09-04/AncillaryDataEvent/build/redhat5-i686-32bit-gcc41-Optimized/libAncillaryDataEvent.a differ
Binary files 20-09-03/AncillaryDataEvent/build/redhat5-i686-32bit-gcc41-Optimized/test_AncillaryDataEvent and 20-09-04/AncillaryDataEvent/build/redhat5-i686-32bit-gcc41-Optimized/test_AncillaryDataEvent differ
Binary files 20-09-03/AncillaryDataUtil/build/redhat5-i686-32bit-gcc41-Optimized/libAncillaryDataUtil.a and 20-09-04/AncillaryDataUtil/build/redhat5-i686-32bit-gcc41-Optimized/libAncillaryDataUtil.a differ
Binary files 20-09-03/AncillaryDataUtil/build/redhat5-i686-32bit-gcc41-Optimized/test_AncillaryDataUtil and 20-09-04/AncillaryDataUtil/build/redhat5-i686-32bit-gcc41-Optimized/test_AncillaryDataUtil differ
Binary files 20-09-03/CHS/eventFile/build/redhat5-i686-32bit-gcc41-Optimized/test_LSEReader and 20-09-04/CHS/eventFile/build/redhat5-i686-32bit-gcc41-Optimized/test_LSEReader differ
Binary files 20-09-03/CHS/eventFile/build/redhat5-i686-32bit-gcc41-Optimized/writeMerge and 20-09-04/CHS/eventFile/build/redhat5-i686-32bit-gcc41-Optimized/writeMerge differ
Binary files 20-09-03/CRflux/build/redhat5-i686-32bit-gcc41-Optimized/test_CRflux and 20-09-04/CRflux/build/redhat5-i686-32bit-gcc41-Optimized/test_CRflux differ
Binary files 20-09-03/CalDigi/build/redhat5-i686-32bit-gcc41-Optimized/test_CalDigi and 20-09-04/CalDigi/build/redhat5-i686-32bit-gcc41-Optimized/test_CalDigi differ
Binary files 20-09-03/CalRecon/build/redhat5-i686-32bit-gcc41-Optimized/test_CalRecon and 20-09-04/CalRecon/build/redhat5-i686-32bit-gcc41-Optimized/test_CalRecon differ
Binary files 20-09-03/CalUtil/build/redhat5-i686-32bit-gcc41-Optimized/test_CalUtil and 20-09-04/CalUtil/build/redhat5-i686-32bit-gcc41-Optimized/test_CalUtil differ
Binary files 20-09-03/CalXtalResponse/build/redhat5-i686-32bit-gcc41-Optimized/test_CalXtalResponse and 20-09-04/CalXtalResponse/build/redhat5-i686-32bit-gcc41-Optimized/test_CalXtalResponse differ
Binary files 20-09-03/CalibSvc/build/redhat5-i686-32bit-gcc41-Optimized/test_CalibSvc and 20-09-04/CalibSvc/build/redhat5-i686-32bit-gcc41-Optimized/test_CalibSvc differ
Binary files 20-09-03/DetDisplay/build/redhat5-i686-32bit-gcc41-Optimized/TestDetDisplay and 20-09-04/DetDisplay/build/redhat5-i686-32bit-gcc41-Optimized/TestDetDisplay differ
Binary files 20-09-03/EbfWriter/build/redhat5-i686-32bit-gcc41-Optimized/test_EbfWriter and 20-09-04/EbfWriter/build/redhat5-i686-32bit-gcc41-Optimized/test_EbfWriter differ
Binary files 20-09-03/Event/build/redhat5-i686-32bit-gcc41-Optimized/test_Event and 20-09-04/Event/build/redhat5-i686-32bit-gcc41-Optimized/test_Event differ
Binary files 20-09-03/Event/build/redhat5-i686-32bit-gcc41-Optimized/test_Tables and 20-09-04/Event/build/redhat5-i686-32bit-gcc41-Optimized/test_Tables differ
Binary files 20-09-03/Event/build/redhat5-i686-32bit-gcc41-Optimized/test_TkrRecon_Event and 20-09-04/Event/build/redhat5-i686-32bit-gcc41-Optimized/test_TkrRecon_Event differ
Binary files 20-09-03/EventIntegrity/build/redhat5-i686-32bit-gcc41-Optimized/test_EventIntegrity and 20-09-04/EventIntegrity/build/redhat5-i686-32bit-gcc41-Optimized/test_EventIntegrity differ
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmLowEnergyPhysics.cxx 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmLowEnergyPhysics.cxx
--- 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmLowEnergyPhysics.cxx	2011-07-28 01:34:45.000000000 -0700
+++ 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmLowEnergyPhysics.cxx	2011-07-28 01:34:45.000000000 -0700
@@ -21,7 +21,7 @@
 // ********************************************************************
 //
 // $Id: EmLowEnergyPhysics.cxx,v 1.1 2011/07/28 08:34:45 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 //---------------------------------------------------------------------------
 //
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmLowEnergyPhysics.hh 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmLowEnergyPhysics.hh
--- 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmLowEnergyPhysics.hh	2011-07-20 05:36:49.000000000 -0700
+++ 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmLowEnergyPhysics.hh	2011-07-20 05:36:49.000000000 -0700
@@ -22,7 +22,7 @@
 //
 //
 // $Id: EmLowEnergyPhysics.hh,v 1.1 2011/07/20 12:36:49 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 //---------------------------------------------------------------------------
 //
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmStandardPhysics.cxx 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmStandardPhysics.cxx
--- 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmStandardPhysics.cxx	2011-07-28 01:34:45.000000000 -0700
+++ 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmStandardPhysics.cxx	2011-07-28 01:34:45.000000000 -0700
@@ -21,7 +21,7 @@
 // ********************************************************************
 //
 // $Id: EmStandardPhysics.cxx,v 1.1 2011/07/28 08:34:45 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 //---------------------------------------------------------------------------
 //
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmStandardPhysics.hh 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmStandardPhysics.hh
--- 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmStandardPhysics.hh	2011-07-20 05:35:33.000000000 -0700
+++ 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/EmStandardPhysics.hh	2011-07-20 05:35:33.000000000 -0700
@@ -22,7 +22,7 @@
 //
 //
 // $Id: EmStandardPhysics.hh,v 1.1 2011/07/20 12:35:33 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 //---------------------------------------------------------------------------
 //
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/MultipleScattering.cxx 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/MultipleScattering.cxx
--- 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/MultipleScattering.cxx	2011-07-20 05:40:17.000000000 -0700
+++ 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/MultipleScattering.cxx	2011-07-20 05:40:17.000000000 -0700
@@ -22,7 +22,7 @@
 //
 //
 // $Id: MultipleScattering.cxx,v 1.1 2011/07/20 12:40:17 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 // $Id: 
 // --------------------------------------------------------------
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/MultipleScattering.h 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/MultipleScattering.h
--- 20-09-03/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/MultipleScattering.h	2011-07-20 05:40:17.000000000 -0700
+++ 20-09-04/G4Generator/build/redhat5-i686-32bit-gcc41-Optimized/src/MultipleScattering.h	2011-07-20 05:40:17.000000000 -0700
@@ -22,7 +22,7 @@
 //
 //
 // $Id: MultipleScattering.h,v 1.1 2011/07/20 12:40:17 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 // $Id:
 // --------------------------------------------------------------
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/src/EmLowEnergyPhysics.cxx 20-09-04/G4Generator/src/EmLowEnergyPhysics.cxx
--- 20-09-03/G4Generator/src/EmLowEnergyPhysics.cxx	2011-07-28 01:34:45.000000000 -0700
+++ 20-09-04/G4Generator/src/EmLowEnergyPhysics.cxx	2011-07-28 01:34:45.000000000 -0700
@@ -21,7 +21,7 @@
 // ********************************************************************
 //
 // $Id: EmLowEnergyPhysics.cxx,v 1.1 2011/07/28 08:34:45 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 //---------------------------------------------------------------------------
 //
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/src/EmLowEnergyPhysics.hh 20-09-04/G4Generator/src/EmLowEnergyPhysics.hh
--- 20-09-03/G4Generator/src/EmLowEnergyPhysics.hh	2011-07-20 05:36:49.000000000 -0700
+++ 20-09-04/G4Generator/src/EmLowEnergyPhysics.hh	2011-07-20 05:36:49.000000000 -0700
@@ -22,7 +22,7 @@
 //
 //
 // $Id: EmLowEnergyPhysics.hh,v 1.1 2011/07/20 12:36:49 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 //---------------------------------------------------------------------------
 //
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/src/EmStandardPhysics.cxx 20-09-04/G4Generator/src/EmStandardPhysics.cxx
--- 20-09-03/G4Generator/src/EmStandardPhysics.cxx	2011-07-28 01:34:45.000000000 -0700
+++ 20-09-04/G4Generator/src/EmStandardPhysics.cxx	2011-07-28 01:34:45.000000000 -0700
@@ -21,7 +21,7 @@
 // ********************************************************************
 //
 // $Id: EmStandardPhysics.cxx,v 1.1 2011/07/28 08:34:45 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 //---------------------------------------------------------------------------
 //
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/src/EmStandardPhysics.hh 20-09-04/G4Generator/src/EmStandardPhysics.hh
--- 20-09-03/G4Generator/src/EmStandardPhysics.hh	2011-07-20 05:35:33.000000000 -0700
+++ 20-09-04/G4Generator/src/EmStandardPhysics.hh	2011-07-20 05:35:33.000000000 -0700
@@ -22,7 +22,7 @@
 //
 //
 // $Id: EmStandardPhysics.hh,v 1.1 2011/07/20 12:35:33 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 //---------------------------------------------------------------------------
 //
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/src/MultipleScattering.cxx 20-09-04/G4Generator/src/MultipleScattering.cxx
--- 20-09-03/G4Generator/src/MultipleScattering.cxx	2011-07-20 05:40:17.000000000 -0700
+++ 20-09-04/G4Generator/src/MultipleScattering.cxx	2011-07-20 05:40:17.000000000 -0700
@@ -22,7 +22,7 @@
 //
 //
 // $Id: MultipleScattering.cxx,v 1.1 2011/07/20 12:40:17 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 // $Id: 
 // --------------------------------------------------------------
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/G4Generator/src/MultipleScattering.h 20-09-04/G4Generator/src/MultipleScattering.h
--- 20-09-03/G4Generator/src/MultipleScattering.h	2011-07-20 05:40:17.000000000 -0700
+++ 20-09-04/G4Generator/src/MultipleScattering.h	2011-07-20 05:40:17.000000000 -0700
@@ -22,7 +22,7 @@
 //
 //
 // $Id: MultipleScattering.h,v 1.1 2011/07/20 12:40:17 flongo Exp $
-// GEANT4 tag $Name: GlastRelease-20-09-03 $
+// GEANT4 tag $Name: GlastRelease-20-09-04 $
 //
 // $Id:
 // --------------------------------------------------------------
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/SConscript 20-09-04/TkrRecon/SConscript
--- 20-09-03/TkrRecon/SConscript	2013-06-25 09:59:54.000000000 -0700
+++ 20-09-04/TkrRecon/SConscript	2013-09-02 12:56:41.000000000 -0700
@@ -1,7 +1,7 @@
 # -*- python -*-
-# $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/SConscript,v 1.102 2013/06/25 16:59:54 usher Exp $ 
+# $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/SConscript,v 1.104 2013/09/02 19:56:41 usher Exp $ 
 # Authors: Leon Rochester <lsrea@slac.stanford.edu>, Tracy Usher <usher@slac.stanford.edu>
-# Version: TkrRecon-10-40-02
+# Version: TkrRecon-10-40-04
 Import('baseEnv')
 Import('listFiles')
 Import('packages')
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/SConscript 20-09-04/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/SConscript
--- 20-09-03/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/SConscript	2013-06-25 09:59:54.000000000 -0700
+++ 20-09-04/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/SConscript	2013-09-02 12:56:41.000000000 -0700
@@ -1,7 +1,7 @@
 # -*- python -*-
-# $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/SConscript,v 1.102 2013/06/25 16:59:54 usher Exp $ 
+# $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/SConscript,v 1.104 2013/09/02 19:56:41 usher Exp $ 
 # Authors: Leon Rochester <lsrea@slac.stanford.edu>, Tracy Usher <usher@slac.stanford.edu>
-# Version: TkrRecon-10-40-02
+# Version: TkrRecon-10-40-04
 Import('baseEnv')
 Import('listFiles')
 Import('packages')
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/src/GaudiAlg/TkrFindAlg.cxx 20-09-04/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/src/GaudiAlg/TkrFindAlg.cxx
--- 20-09-03/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/src/GaudiAlg/TkrFindAlg.cxx	2013-04-23 13:23:30.000000000 -0700
+++ 20-09-04/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/src/GaudiAlg/TkrFindAlg.cxx	2013-09-02 10:56:12.000000000 -0700
@@ -1,5 +1,5 @@
 // File and Version Information:
-//      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx,v 1.38 2013/04/23 20:23:30 lsrea Exp $
+//      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx,v 1.39 2013/09/02 17:56:12 lsrea Exp $
 //
 // Description:
 //      Contains the implementation of the methods for running the pattern recognition
@@ -48,7 +48,7 @@
  * 
  * @author Tracy Usher
  *
- * $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx,v 1.38 2013/04/23 20:23:30 lsrea Exp $
+ * $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx,v 1.39 2013/09/02 17:56:12 lsrea Exp $
  */
 
 class TkrFindAlg : public Algorithm
@@ -82,6 +82,8 @@
     bool     m_doStandardFinding;
     bool     m_CRGhosts;
     bool     m_standardGhosts;
+    bool     m_doStandardTrackDeghosting;
+    bool     m_doCRTrackDeghosting;
 };
 
 //static const AlgFactory<TkrFindAlg>  Factory;
@@ -94,9 +96,12 @@
     declareProperty("TrackFindType",   m_TrackFindType="TreeBased"); 
     declareProperty("DoCRFinding",     m_doCRFinding=true);
     declareProperty("CRGhosts",        m_CRGhosts=true);
+    declareProperty("DoCRTrackDeghosting", m_doCRTrackDeghosting=false);
 
     declareProperty("DoStandardFinding", m_doStandardFinding=true);
     declareProperty("StandardGhosts",    m_standardGhosts=false);
+    declareProperty("DoStandardTrackDeghosting", m_doStandardTrackDeghosting=false);
+
     
 }
 
@@ -296,7 +301,7 @@
         sc = m_CRFindTool->firstPass();
         
         if(m_ghostTool && m_CRGhosts) {
-            sc = m_ghostTool->flagEarlyTracks();
+            if(m_doCRTrackDeghosting) sc = m_ghostTool->flagEarlyTracks();
             sc = m_ghostTool->flagEarlyCalClusters();
         }
     }
@@ -316,7 +321,7 @@
         else                         sc = m_findTool->secondPass();
 
         if(m_ghostTool && m_standardGhosts) {
-            sc = m_ghostTool->flagEarlyTracks();
+            if(m_doStandardTrackDeghosting) sc = m_ghostTool->flagEarlyTracks();
         }
     }
 
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/src/GaudiAlg/TkrTrackFitAlg.cxx 20-09-04/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/src/GaudiAlg/TkrTrackFitAlg.cxx
--- 20-09-03/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/src/GaudiAlg/TkrTrackFitAlg.cxx	2013-04-23 13:23:30.000000000 -0700
+++ 20-09-04/TkrRecon/build/redhat5-i686-32bit-gcc41-Optimized/src/GaudiAlg/TkrTrackFitAlg.cxx	2013-08-23 08:56:55.000000000 -0700
@@ -13,7 +13,7 @@
  * @author The Tracking Software Group
  *
  * File and Version Information:
- *      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrTrackFitAlg.cxx,v 1.37 2013/04/23 20:23:30 lsrea Exp $
+ *      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrTrackFitAlg.cxx,v 1.38 2013/08/23 15:56:55 usher Exp $
  */
 
 #include <vector>
@@ -56,6 +56,10 @@
     /// First pass track fit
     StatusCode doTrackFit();
     StatusCode doTrackReFit();
+    StatusCode doAfterBurner();
+
+    /// Function to do the work for this instance
+    StatusCode (TkrTrackFitAlg::*m_fitAlgorithm)(void);
 
     /// Type of fit to perform
     std::string  m_TrackFitType;
@@ -145,6 +149,11 @@
     sc = toolSvc()->retrieveTool(m_energyToolName,   m_energyTool);
     sc = toolSvc()->retrieveTool("TkrAlignHitsTool", m_AlignTool);
 
+    // Finally, set the actual fit algorithm
+    if (name()      == "AfterBurner") m_fitAlgorithm = &TkrTrackFitAlg::doAfterBurner;
+    else if (name() == "TkrFitIter")  m_fitAlgorithm = &TkrTrackFitAlg::doTrackReFit;
+    else                              m_fitAlgorithm = &TkrTrackFitAlg::doTrackFit;
+
     return sc;
 }
 
@@ -156,11 +165,11 @@
     // Dependencies: None
     // Restrictions and Caveats:  None
 
-    StatusCode sc = StatusCode::SUCCESS;
+    StatusCode sc = (this->*m_fitAlgorithm)();
 
     // What to do depends upon first track fit or iteration
-    if (name() != "TkrFitIter") sc = doTrackFit();
-    else                        sc = doTrackReFit();
+//    if (name() != "TkrFitIter") sc = doTrackFit();
+//    else                        sc = doTrackReFit();
 
     return sc;
 }
@@ -239,6 +248,43 @@
     return sc;
 }
 
+StatusCode TkrTrackFitAlg::doAfterBurner()
+{
+    // Purpose and Method: Called each event for iteration of the track fit
+    // Inputs:  None
+    // Outputs:  StatusCode upon completetion
+    // Dependencies: None
+    // Restrictions and Caveats:  None
+
+    MsgStream log(msgSvc(), name());
+    StatusCode sc = StatusCode::SUCCESS;
+
+    log << MSG::DEBUG; 
+    if (log.isActive()) {
+        log << "------- TkrRecon Track Fit Afterburner --------";
+    }
+    log << endreq;
+  
+    // Find the collection of candidate tracks
+    Event::TkrTrackCol* trackCol = SmartDataPtr<Event::TkrTrackCol>(eventSvc(),EventModel::TkrRecon::TkrTrackCol);
+
+    // Check that there are tracks to fit
+    if(!trackCol) return sc;
+    if(trackCol->size() < 1) return sc;
+
+    // Ok, now set up to loop over candidate tracks
+    for(Event::TkrTrackColPtr trackIter = trackCol->begin(); trackIter != trackCol->end(); trackIter++)
+    {
+        Event::TkrTrack* track = *trackIter;
+        if (!(track->getStatusBits() & Event::TkrTrack::COSMICRAY)) {   // RJ: don't refit cosmic-ray candidates
+            if (m_doAlignment) m_AlignTool->alignHits(track);
+            m_FitTool->doTrackReFit(track);
+        }
+    }
+
+    return sc;
+}
+
 StatusCode TkrTrackFitAlg::finalize()
 {   
     return StatusCode::SUCCESS;
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/cmt/requirements 20-09-04/TkrRecon/cmt/requirements
--- 20-09-03/TkrRecon/cmt/requirements	2013-06-25 09:59:55.000000000 -0700
+++ 20-09-04/TkrRecon/cmt/requirements	2013-09-02 12:56:42.000000000 -0700
@@ -1,5 +1,5 @@
 package TkrRecon
-version v10r40p2
+version v10r40p4
 
 author Tracy Usher <usher@slac.stanford.edu> 
 author Leon Rochester <lsrea@slac.stanford.edu>  
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/doc/release.notes 20-09-04/TkrRecon/doc/release.notes
--- 20-09-03/TkrRecon/doc/release.notes	2013-06-25 09:59:56.000000000 -0700
+++ 20-09-04/TkrRecon/doc/release.notes	2013-09-02 12:56:43.000000000 -0700
@@ -4,6 +4,8 @@
   Managers: Tracy Usher, Leon Rochester 
   * EOH *
 
+ TkrRecon-10-40-04 02-Sep-2013 TU restore correct version of track fitter 
+ TkrRecon-10-40-03 02-Sep-2013  lsrea turn off track deghosting by default in CR (and standard)
  TkrRecon-10-40-02 25-Jun-2013 TU Fix bugs which caused non-repeatability between runs
  TkrRecon-10-40-01 14-Jun-2013 TU Make sure Tree auditor vars zeroed in "start"
  TkrRecon-10-40-00 31-May-2013 TU Toolify the TkrVecPoints builder and include "merge cluster" capability to kill long cpu time events
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx 20-09-04/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx
--- 20-09-03/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx	2013-04-23 13:23:30.000000000 -0700
+++ 20-09-04/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx	2013-09-02 10:56:12.000000000 -0700
@@ -1,5 +1,5 @@
 // File and Version Information:
-//      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx,v 1.38 2013/04/23 20:23:30 lsrea Exp $
+//      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx,v 1.39 2013/09/02 17:56:12 lsrea Exp $
 //
 // Description:
 //      Contains the implementation of the methods for running the pattern recognition
@@ -48,7 +48,7 @@
  * 
  * @author Tracy Usher
  *
- * $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx,v 1.38 2013/04/23 20:23:30 lsrea Exp $
+ * $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrFindAlg.cxx,v 1.39 2013/09/02 17:56:12 lsrea Exp $
  */
 
 class TkrFindAlg : public Algorithm
@@ -82,6 +82,8 @@
     bool     m_doStandardFinding;
     bool     m_CRGhosts;
     bool     m_standardGhosts;
+    bool     m_doStandardTrackDeghosting;
+    bool     m_doCRTrackDeghosting;
 };
 
 //static const AlgFactory<TkrFindAlg>  Factory;
@@ -94,9 +96,12 @@
     declareProperty("TrackFindType",   m_TrackFindType="TreeBased"); 
     declareProperty("DoCRFinding",     m_doCRFinding=true);
     declareProperty("CRGhosts",        m_CRGhosts=true);
+    declareProperty("DoCRTrackDeghosting", m_doCRTrackDeghosting=false);
 
     declareProperty("DoStandardFinding", m_doStandardFinding=true);
     declareProperty("StandardGhosts",    m_standardGhosts=false);
+    declareProperty("DoStandardTrackDeghosting", m_doStandardTrackDeghosting=false);
+
     
 }
 
@@ -296,7 +301,7 @@
         sc = m_CRFindTool->firstPass();
         
         if(m_ghostTool && m_CRGhosts) {
-            sc = m_ghostTool->flagEarlyTracks();
+            if(m_doCRTrackDeghosting) sc = m_ghostTool->flagEarlyTracks();
             sc = m_ghostTool->flagEarlyCalClusters();
         }
     }
@@ -316,7 +321,7 @@
         else                         sc = m_findTool->secondPass();
 
         if(m_ghostTool && m_standardGhosts) {
-            sc = m_ghostTool->flagEarlyTracks();
+            if(m_doStandardTrackDeghosting) sc = m_ghostTool->flagEarlyTracks();
         }
     }
 
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/src/GaudiAlg/TkrTrackFitAlg.cxx 20-09-04/TkrRecon/src/GaudiAlg/TkrTrackFitAlg.cxx
--- 20-09-03/TkrRecon/src/GaudiAlg/TkrTrackFitAlg.cxx	2013-04-23 13:23:30.000000000 -0700
+++ 20-09-04/TkrRecon/src/GaudiAlg/TkrTrackFitAlg.cxx	2013-08-23 08:56:55.000000000 -0700
@@ -13,7 +13,7 @@
  * @author The Tracking Software Group
  *
  * File and Version Information:
- *      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrTrackFitAlg.cxx,v 1.37 2013/04/23 20:23:30 lsrea Exp $
+ *      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/GaudiAlg/TkrTrackFitAlg.cxx,v 1.38 2013/08/23 15:56:55 usher Exp $
  */
 
 #include <vector>
@@ -56,6 +56,10 @@
     /// First pass track fit
     StatusCode doTrackFit();
     StatusCode doTrackReFit();
+    StatusCode doAfterBurner();
+
+    /// Function to do the work for this instance
+    StatusCode (TkrTrackFitAlg::*m_fitAlgorithm)(void);
 
     /// Type of fit to perform
     std::string  m_TrackFitType;
@@ -145,6 +149,11 @@
     sc = toolSvc()->retrieveTool(m_energyToolName,   m_energyTool);
     sc = toolSvc()->retrieveTool("TkrAlignHitsTool", m_AlignTool);
 
+    // Finally, set the actual fit algorithm
+    if (name()      == "AfterBurner") m_fitAlgorithm = &TkrTrackFitAlg::doAfterBurner;
+    else if (name() == "TkrFitIter")  m_fitAlgorithm = &TkrTrackFitAlg::doTrackReFit;
+    else                              m_fitAlgorithm = &TkrTrackFitAlg::doTrackFit;
+
     return sc;
 }
 
@@ -156,11 +165,11 @@
     // Dependencies: None
     // Restrictions and Caveats:  None
 
-    StatusCode sc = StatusCode::SUCCESS;
+    StatusCode sc = (this->*m_fitAlgorithm)();
 
     // What to do depends upon first track fit or iteration
-    if (name() != "TkrFitIter") sc = doTrackFit();
-    else                        sc = doTrackReFit();
+//    if (name() != "TkrFitIter") sc = doTrackFit();
+//    else                        sc = doTrackReFit();
 
     return sc;
 }
@@ -239,6 +248,43 @@
     return sc;
 }
 
+StatusCode TkrTrackFitAlg::doAfterBurner()
+{
+    // Purpose and Method: Called each event for iteration of the track fit
+    // Inputs:  None
+    // Outputs:  StatusCode upon completetion
+    // Dependencies: None
+    // Restrictions and Caveats:  None
+
+    MsgStream log(msgSvc(), name());
+    StatusCode sc = StatusCode::SUCCESS;
+
+    log << MSG::DEBUG; 
+    if (log.isActive()) {
+        log << "------- TkrRecon Track Fit Afterburner --------";
+    }
+    log << endreq;
+  
+    // Find the collection of candidate tracks
+    Event::TkrTrackCol* trackCol = SmartDataPtr<Event::TkrTrackCol>(eventSvc(),EventModel::TkrRecon::TkrTrackCol);
+
+    // Check that there are tracks to fit
+    if(!trackCol) return sc;
+    if(trackCol->size() < 1) return sc;
+
+    // Ok, now set up to loop over candidate tracks
+    for(Event::TkrTrackColPtr trackIter = trackCol->begin(); trackIter != trackCol->end(); trackIter++)
+    {
+        Event::TkrTrack* track = *trackIter;
+        if (!(track->getStatusBits() & Event::TkrTrack::COSMICRAY)) {   // RJ: don't refit cosmic-ray candidates
+            if (m_doAlignment) m_AlignTool->alignHits(track);
+            m_FitTool->doTrackReFit(track);
+        }
+    }
+
+    return sc;
+}
+
 StatusCode TkrTrackFitAlg::finalize()
 {   
     return StatusCode::SUCCESS;
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrRecon/src/Track/KalmanTrackFitTool.cxx 20-09-04/TkrRecon/src/Track/KalmanTrackFitTool.cxx
--- 20-09-03/TkrRecon/src/Track/KalmanTrackFitTool.cxx	2013-05-10 11:15:50.000000000 -0700
+++ 20-09-04/TkrRecon/src/Track/KalmanTrackFitTool.cxx	2013-09-02 12:54:49.000000000 -0700
@@ -10,7 +10,7 @@
  * @author Tracy Usher
  *
  * File and Version Information:
- *      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/Track/KalmanTrackFitTool.cxx,v 1.68 2013/05/10 18:15:50 usher Exp $
+ *      $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrRecon/src/Track/KalmanTrackFitTool.cxx,v 1.73 2013/09/02 19:54:49 usher Exp $
  */
 
 // to turn one debug variables
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrUtil/SConscript 20-09-04/TkrUtil/SConscript
--- 20-09-03/TkrUtil/SConscript	2013-08-29 13:22:55.000000000 -0700
+++ 20-09-04/TkrUtil/SConscript	2013-09-02 11:58:45.000000000 -0700
@@ -1,7 +1,7 @@
 # -*- python -*-
-# $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrUtil/SConscript,v 1.77 2013/08/29 20:22:55 lsrea Exp $
+# $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrUtil/SConscript,v 1.78 2013/09/02 18:58:45 lsrea Exp $
 # Authors: Leon Rochester <lsrea@slac.stanford.edu>
-# Version: TkrUtil-03-28-08
+# Version: TkrUtil-03-28-09
 Import('baseEnv')
 Import('listFiles')
 Import('packages')
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrUtil/build/redhat5-i686-32bit-gcc41-Optimized/SConscript 20-09-04/TkrUtil/build/redhat5-i686-32bit-gcc41-Optimized/SConscript
--- 20-09-03/TkrUtil/build/redhat5-i686-32bit-gcc41-Optimized/SConscript	2013-08-29 13:22:55.000000000 -0700
+++ 20-09-04/TkrUtil/build/redhat5-i686-32bit-gcc41-Optimized/SConscript	2013-09-02 11:58:45.000000000 -0700
@@ -1,7 +1,7 @@
 # -*- python -*-
-# $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrUtil/SConscript,v 1.77 2013/08/29 20:22:55 lsrea Exp $
+# $Header: /nfs/slac/g/glast/ground/cvs/GlastRelease-scons/TkrUtil/SConscript,v 1.78 2013/09/02 18:58:45 lsrea Exp $
 # Authors: Leon Rochester <lsrea@slac.stanford.edu>
-# Version: TkrUtil-03-28-08
+# Version: TkrUtil-03-28-09
 Import('baseEnv')
 Import('listFiles')
 Import('packages')
diff -urbB -x '*.exe' -x '*.o*' -x '*.so' -x '*.pyc' -x Doxygen -x CVS -x 'ChangeLog*' 20-09-03/TkrUtil/cmt/requirements 20-09-04/TkrUtil/cmt/requirements
--- 20-09-03/TkrUtil/cmt/requirements	2013-08-29 13:22:56.000000000 -0700
+++ 20-09-04/TkrUtil/cmt/requirements	2013-09-02 11:58:45.000000000 -0700
@@ -1,6 +1,6 @@
 package TkrUtil
 
-version v3r28p8
+version v3r28p9
 
 author Leon Rochester <lsrea@slac.stanford.edu>
 
